#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1700one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 1700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1700one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one17004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                         
# -------------------------------------------------------------------------------------------------
# 1700
# -------------------------------------------------------------------------------------------------                                          
shot2one17004xi = {
                  1:'0x0y1699z',
                  2:'0x1125y1274z',
                  3:'0x51y1699z',
                  4:'1010x708y1169z',
                  5:'1026x1070y831z',
                  6:'1033x933y974z',
                  7:'1073x872y988z',
                  8:'1075x1009y845z',
                  9:'1109x808y1002z',
                  10:'1120x946y860z',
                  11:'112x1283y1108z',
                  12:'114x1093y1296z',
                  13:'1161x880y875z',
                  14:'132x1572y631z',
                  15:'155x1507y770z',
                  16:'16x185y1689z',
                  17:'170x1073y1307z',
                  18:'170x1393y958z',
                  19:'177x1264y1121z',
                  20:'18x28y1699z',
                  21:'1x17y1699z',
                  22:'1x34y1699z',
                  23:'213x1557y647z',
                  24:'223x1050y1318z',
                  25:'233x1489y786z',
                  26:'241x1242y1134z',
                  27:'241x1373y972z',
                  28:'24x1422y930z',
                  29:'24x168y1691z',
                  30:'24x44y1699z',
                  31:'274x1024y1328z',
                  32:'293x1537y663z',
                  33:'29x149y1693z',
                  34:'303x1217y1147z',
                  35:'309x1467y801z',
                  36:'30x61y1698z',
                  37:'310x1349y986z',
                  38:'323x995y1339z',
                  39:'33x131y1694z',
                  40:'33x78y1697z',
                  41:'35x113y1695z',
                  42:'35x95y1696z',
                  43:'363x1188y1159z',
                  44:'370x965y1349z',
                  45:'372x1513y678z',
                  46:'378x1321y1000z',
                  47:'383x1441y816z',
                  48:'414x931y1359z',
                  49:'421x1157y1171z',
                  50:'443x1290y1013z',
                  51:'448x1485y694z',
                  52:'456x1411y830z',
                  53:'456x896y1370z',
                  54:'45x1298y1095z',
                  55:'476x1122y1184z',
                  56:'496x859y1380z',
                  57:'506x1256y1027z',
                  58:'50x1583y615z',
                  59:'523x1453y709z',
                  60:'526x1377y845z',
                  61:'529x1085y1196z',
                  62:'533x820y1389z',
                  63:'53x41y1698z',
                  64:'567x1218y1040z',
                  65:'567x780y1399z',
                  66:'579x1045y1208z',
                  67:'58x1111y1285z',
                  68:'594x1340y860z',
                  69:'596x1417y725z',
                  70:'598x738y1409z',
                  71:'625x1177y1054z',
                  72:'626x696y1418z',
                  73:'627x1003y1220z',
                  74:'64x55y1697z',
                  75:'652x652y1427z',
                  76:'659x1299y875z',
                  77:'666x1377y740z',
                  78:'671x959y1232z',
                  79:'674x607y1437z',
                  80:'680x1134y1067z',
                  81:'694x562y1446z',
                  82:'711x516y1454z',
                  83:'713x913y1243z',
                  84:'722x1255y889z',
                  85:'733x1088y1080z',
                  86:'733x1334y755z',
                  87:'73x70y1696z',
                  88:'752x865y1255z',
                  89:'77x1520y755z',
                  90:'782x1039y1093z',
                  91:'782x1208y903z',
                  92:'787x815y1266z',
                  93:'798x1287y771z',
                  94:'7x203y1687z',
                  95:'819x764y1277z',
                  96:'81x86y1695z',
                  97:'828x988y1106z',
                  98:'839x1158y918z',
                  99:'849x712y1289z',
                  100:'860x1237y786z',
                  101:'871x936y1119z',
                  102:'874x659y1300z',
                  103:'87x103y1694z',
                  104:'892x1106y932z',
                  105:'897x605y1310z',
                  106:'911x881y1132z',
                  107:'919x1184y801z',
                  108:'92x121y1693z',
                  109:'943x1050y946z',
                  110:'947x824y1144z',
                  111:'95x140y1691z',
                  112:'95x179y1687z',
                  113:'96x159y1689z',
                  114:'974x1128y816z',
                  115:'97x1410y944z',
                  116:'980x767y1157z',
                  117:'98x211y1784z',
                  118:'990x993y960z',
                  119:'9x13y1699z'}
                         

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1700one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1700one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE170ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE170ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE170ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE170ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE170ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE17004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one17004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE170ONE4XI - SUCCEEDED TO PUT SHOT2ONE17004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE17004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE170ONE4XI *** FAILED TO PUT SHOT2ONE17004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE170ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one17004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one17004xi</nack2put4xi>" 
                   
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
  
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE170ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one17004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE170ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE170ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1700one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
